Index: cprs/trunk/CPRS-Chart/fGraphs.pas
===================================================================
--- cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 830)
@@ -2079,17 +2157,579 @@
     chartDatelineBottom.LeftAxis.Maximum := chartDatelineBottom.LeftAxis.Maximum + 0.5;
   end;
+  if FGraphSetting.Hints then
+  begin
+    chartDatelineTop.OnMouseMove := chartBaseMouseMove;
+    chartDatelineBottom.OnMouseMove := chartBaseMouseMove;
+  end
+  else
+  begin
+    chartDatelineTop.OnMouseMove := nil;
+    chartDatelineBottom.OnMouseMove := nil;
+  end;
   AdjustTimeframe;
   if chartDatelineTop.Visible then chartDatelineTop.ZoomPercent(ZOOM_PERCENT);
   if chartDatelineBottom.Visible then chartDatelineBottom.ZoomPercent(ZOOM_PERCENT);
-  if FNonNumerics then
-    if section = 'top' then pnlItemsTop.Tag := 1
-    else pnlItemsBottom.Tag := 1;
-end;
-
-function TfrmGraphs.PortionSize(lcnt, pcnt, gcnt, vcnt, bcnt, acnt: integer): double;
+end;
+
+procedure TfrmGraphs.MakeTogetherNoLines(aListView: TListView; section: string);
+var
+  bcnt, gcnt, graphtype, pcnt, vcnt: integer;
+  aTitle, filetype, typeitem: string;
+  aGraphItem: TGraphItem;
+  aListItem: TListItem;
+begin
+  pcnt := 0; gcnt := 0; vcnt := 0; bcnt := 0;
+  aListItem := aListView.Selected;
+  while aListItem <> nil do
+  begin
+    aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
+    filetype := Piece(aGraphItem.Values, '^', 1);
+    typeitem := Piece(aGraphItem.Values, '^', 2);
+    aTitle := filetype + '^' + typeitem + '^' + aListItem.Caption + '^';
+    graphtype := GraphTypeNum(filetype);
+    if section = 'top' then
+      MakeDateline(section, aTitle, filetype, chartDatelineTop, graphtype, bcnt, pcnt, gcnt, vcnt)
+    else
+      MakeDateline(section, aTitle, filetype, chartDatelineBottom, graphtype, bcnt, pcnt, gcnt, vcnt);
+    aListItem := aListView.GetNextItem(aListItem, sdAll, [isSelected]);
+  end;
+  if section = 'top' then
+  begin
+    scrlTop.Align := alTop;
+    scrlTop.Height := 1; //pnlScrollTopBase.Height div 4;
+    pnlDatelineTop.Align := alClient;
+    pnlDatelineTop.Visible := true;
+  end
+  else
+  begin
+    scrlBottom.Align := alTop;
+    scrlBottom.Height := 1; //pnlScrollBottomBase.Height div 4;
+    pnlDatelineBottom.Align := alClient;
+    pnlDatelineBottom.Visible := true;
+  end;
+end;
+
+procedure TfrmGraphs.MakeTogetherOnlyLines(aListView: TListView; section: string; aChart: TChart);
+var
+  lcnt, ncnt: integer;
+  aTitle, filetype, typeitem: string;
+  aGraphItem: TGraphItem;
+  aListItem: TListItem;
+begin
+  lcnt := 0;
+  aListItem := aListView.Selected;
+  while aListItem <> nil do
+  begin
+    aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
+    filetype := Piece(aGraphItem.Values, '^', 1);
+    typeitem := Piece(aGraphItem.Values, '^', 2);
+    aTitle := TitleInfo(filetype, typeitem, aListItem.Caption);
+    MakeLineSeries(aChart, aTitle, filetype, section, lcnt, ncnt, true);
+    if FDisplayFreeText = true then DisplayFreeText(aChart);
+    aListItem := aListView.GetNextItem(aListItem, sdAll, [isSelected]);
+  end;
+  if section = 'top' then
+  begin
+    pnlDatelineTop.Align := alBottom;
+    pnlDatelineTop.Height := 5;
+    scrlTop.Align := alClient;
+    pnlDatelineTop.Visible := false;
+  end
+  else
+  begin
+    pnlDatelineBottom.Align := alBottom;
+    pnlDatelineBottom.Height := 5;
+    scrlBottom.Align := alClient;
+    pnlDatelineBottom.Visible := false;
+  end;
+  with aChart do
+  begin
+    if btnChangeSettings.Tag = 1 then
+      LeftAxis.Title.Caption := 'StdDev';
+    Visible := true;
+  end;
+end;
+
+procedure TfrmGraphs.MakeTogetherAnyLines(aListView: TListView; section: string; aChart: TChart);
+var
+  singletest: boolean;
+  bcnt, gcnt, graphtype, lcnt, ncnt, pcnt, vcnt: integer;
+  aTitle, filetype, typeitem: string;
+  aGraphItem: TGraphItem;
+  aListItem: TListItem;
+begin
+  singletest := SingleLabTest(aListView);
+  pcnt := 0; gcnt := 0; vcnt := 0; lcnt := 0; bcnt := 0;
+  aListItem := aListView.Selected;
+  while aListItem <> nil do
+  begin
+    aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
+    filetype := Piece(aGraphItem.Values, '^', 1);
+    typeitem := Piece(aGraphItem.Values, '^', 2);
+    aTitle := TitleInfo(filetype, typeitem, aListItem.Caption);
+    graphtype := GraphTypeNum(filetype);
+    if graphtype = 1 then
+    begin
+      if btnChangeSettings.Tag = 1 then
+        aChart.LeftAxis.Title.Caption := 'StdDev'
+      else
+        aChart.LeftAxis.Title.Caption := Piece(aTitle, '^', 7);
+      if singletest then
+        splGraphs.Tag := 1
+      else
+        splGraphs.Tag := 0;
+      MakeLineSeries(aChart, aTitle, filetype, section, lcnt, ncnt, true);
+      if FDisplayFreeText = true then DisplayFreeText(aChart);
+    end
+    else if section = 'top' then
+      MakeDateline(section, aTitle, filetype, chartDatelineTop, graphtype, bcnt, pcnt, gcnt, vcnt)
+    else
+      MakeDateline(section, aTitle, filetype, chartDatelineBottom, graphtype, bcnt, pcnt, gcnt, vcnt);
+    aListItem := aListView.GetNextItem(aListItem, sdAll, [isSelected]);
+  end;
+  if section = 'top' then
+  begin
+    scrlTop.Align := alTop;
+    pnlDatelineTop.Align := alBottom;
+    pnlDatelineTop.Height := pnlScrollTopBase.Height div 2;
+    scrlTop.Align := alClient;
+    pnlDatelineTop.Visible := true;
+  end
+  else
+  begin
+    scrlBottom.Align := alTop;
+    pnlDatelineBottom.Align := alBottom;
+    pnlDatelineBottom.Height := pnlScrollBottomBase.Height div 2;
+    scrlBottom.Align := alClient;
+    pnlDatelineBottom.Visible := true;
+  end;
+  with aChart do
+  begin
+    if btnChangeSettings.Tag = 1 then
+      LeftAxis.Title.Caption := 'StdDev';
+    Visible := true;
+  end;
+end;
+
+function TfrmGraphs.SingleLabTest(aListView: TListView): boolean;
+var
+  cnt: integer;
+  filetype: string;
+  aGraphItem: TGraphItem;
+  aListItem: TListItem;
+begin
+  cnt := 0;
+  aListItem := aListView.Selected;
+  while aListItem <> nil do
+  begin
+    aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
+    filetype := Piece(aGraphItem.Values, '^', 1);
+    if filetype = '120.5' then
+    begin
+      cnt := BIG_NUMBER;
+      break;
+    end;
+    if filetype = '63' then
+      cnt := cnt + 1;
+    if cnt > 1 then
+      break;
+    aListItem := aListView.GetNextItem(aListItem, sdAll, [isSelected]);
+  end;
+  Result := (cnt = 1);
+end;
+
+procedure TfrmGraphs.MakeChart(aChart: TChart; aScrollBox: TScrollBox);
+begin
+  with aChart do
+  begin
+    Parent := aScrollBox;
+    View3D := false;
+    Chart3DPercent := 10;
+    AllowPanning := pmNone;
+    Gradient.EndColor := clGradientActiveCaption;
+    Gradient.StartColor := clWindow;
+    Legend.LegendStyle := lsSeries;
+    Legend.ShadowSize := 1;
+    Legend.Color := clCream;
+    Legend.VertMargin := 0;
+    Legend.Alignment := laTop;
+    Legend.Visible := true;
+    BottomAxis.ExactDateTime := true;
+    BottomAxis.Increment := DateTimeStep[dtOneMinute];
+    HideDates(aChart);
+    BevelOuter := bvNone;
+    OnZoom := ChartOnZoom;
+    OnUndoZoom := ChartOnUndoZoom;
+    OnClickSeries := chartBaseClickSeries;
+    OnClickLegend := chartBaseClickLegend;
+    OnDblClick := mnuPopGraphDetailsClick;
+    OnMouseDown := chartBaseMouseDown;
+    OnMouseUp := chartBaseMouseUp;
+    if FGraphSetting.Hints then
+      OnMouseMove := chartBaseMouseMove
+    else
+      OnMouseMove := nil;
+  end;
+end;
+
+procedure TfrmGraphs.MakeSeriesInfo(aChart: TChart; aSeries: TChartSeries; aTitle, aFileType: string; aSerCnt: integer);
+begin
+  with aSeries do
+  begin
+    Active := true;
+    ParentChart := aChart;
+    Title := Piece(aTitle, '^', 3);
+    GetData(aTitle);
+    Identifier := aFileType;
+    SeriesColor := NextColor(aSerCnt);
+    ColorEachPoint := false;
+    ShowInLegend := true;
+    Marks.Style := smsLabel;
+    Marks.BackColor := clInfoBk;
+    Marks.Frame.Visible := true;
+    Marks.Visible := false;
+    OnGetMarkText := serDatelineTop.OnGetMarkText;
+    XValues.DateTime := True;
+    GetHorizAxis.ExactDateTime := True;
+    GetHorizAxis.Increment := DateTimeStep[dtOneMinute];
+  end;
+end;
+
+procedure TfrmGraphs.MakeSeriesPoint(aChart: TChart; aPointSeries: TPointSeries);
+begin
+  with aPointSeries do
+  begin
+    Active := true;
+    ParentChart := aChart;
+    Title := '';
+    Identifier := '';
+    SeriesColor := aChart.Color;
+    ColorEachPoint := false;
+    ShowInLegend := false;
+    Marks.Style := smsLabel;
+    Marks.BackColor := clInfoBk;
+    Marks.Frame.Visible := true;
+    Marks.Visible := false;
+    OnGetMarkText := serDatelineTop.OnGetMarkText;
+    XValues.DateTime := true;
+    Pointer.Visible := true;
+    Pointer.InflateMargins := true;
+    Pointer.Style := psSmallDot;
+    Pointer.Pen.Visible := true;
+  end;
+end;
+
+procedure TfrmGraphs.MakeSeriesRef(aChart: TChart; aTest, aRef: TLineSeries; aTitle, aValue: string; aDate: double);
+var
+  value: double;
+begin
+  with aRef do
+  begin
+    Active := true;
+    ParentChart := aChart;
+    XValues.DateTime := True;
+    Pointer.Visible := false;
+    Pointer.InflateMargins := true;
+    OnGetMarkText := serDatelineTop.OnGetMarkText;
+    ColorEachPoint := false;
+    Title := aTitle + aValue;
+    Pointer.Style := psCircle;
+    SeriesColor := clTeeColor; //aTest.SeriesColor; // clBtnShadow;  // 
+    Marks.Visible := false;
+    LinePen.Visible := true;
+    LinePen.Width := 1;
+    LinePen.Style := psDash;  //does not show when width <> 1
+  end;
+  value := strtofloatdef(aValue, -BIG_NUMBER);
+  if value <> -BIG_NUMBER then
+  begin
+    aRef.AddXY(IncDay(FGraphSetting.LowTime, -1), value, '', clTeeColor);
+    aRef.AddXY(IncDay(FGraphSetting.HighTime, 1), value, '', clTeeColor);
+    BorderValue(aDate, value);
+  end;
+end;
+
+procedure TfrmGraphs.MakeSeriesBP(aChart: TChart; aTest, aBP: TLineSeries; aFileType: string);
+begin
+  with aBP do
+  begin
+    ParentChart := aChart;
+    Title := 'Blood Pressure';
+    XValues.DateTime := true;
+    Pointer.Style := aTest.Pointer.Style;
+    ShowInLegend := false;    //****
+    Identifier := aFileType;
+    Pointer.Visible := true;
+    Pointer.InflateMargins := true;
+    ColorEachPoint := false;
+    SeriesColor := aTest.SeriesColor;
+    Marks.BackColor := clInfoBk;
+  end;
+end;
+
+procedure TfrmGraphs.MakeOtherSeries(aChart: TChart);
+begin
+  if GtslNonNum.Count > 0 then
+  begin
+    MakeNonNumerics(aChart);
+    if FDisplayFreeText = true then DisplayFreeText(aChart);
+  end;
+  if length(aChart.Hint) > 0 then
+  begin
+    MakeComments(aChart);
+  end;
+end;
+
+procedure TfrmGraphs.MakeComments(aChart: TChart);
+var
+  serComment: TPointSeries;
+begin
+  serComment := TPointSeries.Create(aChart);
+  MakeSeriesPoint(aChart, serComment);
+  with serComment do
+  begin
+    Identifier := 'serComments';
+    Title := TXT_COMMENTS;
+    SeriesColor := clTeeColor;
+    Marks.ArrowLength := -24;
+    Marks.Visible := true;
+    end;
+end;
+
+procedure TfrmGraphs.MakeNonNumerics(aChart: TChart);
+var
+  nonnumericonly, nonnumsection: boolean;
+  i, bmax, tmax: integer;
+  padvalue, highestvalue, lowestvalue, diffvalue: double;
+  astring, listofseries, section: string;
+  serBlank: TPointSeries;
+begin
+  if aChart.Parent = scrlBottom then section := 'bottom'
+  else section := 'top';
+  nonnumericonly := true;
+  for i := 0 to aChart.SeriesCount - 1 do
+  begin
+    if (aChart.Series[i] is TLineSeries) then
+      if aChart.Series[i].Count > 0 then
+      begin
+        nonnumericonly := false;
+        break;
+      end;
+  end;
+  PadNonNum(aChart, section, listofseries, bmax, tmax);
+  if bmax = 0 then bmax := 1;
+  if tmax = 0 then tmax := 1;
+  if nonnumericonly then
+  begin
+    highestvalue := 1;
+    lowestvalue := 0;
+  end
+  else
+  begin
+    highestvalue := aChart.MaxYValue(aChart.LeftAxis);
+    lowestvalue := aChart.MinYValue(aChart.LeftAxis);
+  end;
+  diffvalue := highestvalue - lowestvalue;
+  if diffvalue = 0 then
+    padvalue := highestvalue / 2
+  else
+    padvalue := POINT_PADDING * diffvalue;
+  highestvalue := highestvalue + (tmax * padvalue);
+  lowestvalue := lowestvalue - (bmax * padvalue);
+  if not (aChart.MinYValue(aChart.LeftAxis) < 0) then
+  begin
+    if highestvalue < 0 then highestvalue := 0;
+    if lowestvalue < 0 then lowestvalue := 0;
+  end;
+  if lowestvalue > highestvalue then
+     lowestvalue := highestvalue;
+  aChart.LeftAxis.Maximum := highestvalue;
+  aChart.LeftAxis.Minimum := lowestvalue;
+  nonnumsection := false;
+  for i := 0 to GtslNonNum.Count - 1 do
+  begin
+    astring := GtslNonNum[i];
+    if Piece(astring, '^', 7) = section then
+    begin
+      nonnumsection := true;
+      break;
+    end;
+  end;
+  if nonnumericonly and nonnumsection then
+  begin
+    serBlank := TPointSeries.Create(aChart);
+    MakeSeriesPoint(aChart, serBlank);
+    with serBlank do
+    begin
+      AddXY(aChart.BottomAxis.Minimum, highestvalue, '', aChart.Color);
+      AddXY(aChart.BottomAxis.Minimum, lowestvalue, '', aChart.Color);
+    end;
+    aChart.LeftAxis.Labels := false;
+    aChart.MarginLeft := PadLeftNonNumeric(pnlScrollTopBase.Width);
+    //aChart.MarginLeft := round((40 / (pnlScrollTopBase.Width + 1)) * 100);       // ************* marginleft is a %
+    ChartOnUndoZoom(aChart);
+  end;
+  MakeNonNumSeries(aChart, padvalue, highestvalue, lowestvalue, listofseries, section);
+end;
+
+procedure TfrmGraphs.MakeNonNumSeries(aChart: TChart; padvalue, highestvalue, lowestvalue: double; listofseries, section: string);
+var
+  asernum, i, j, originalindex, linenum, offset: integer;
+  nonvalue, graphvalue: double;
+  avalue, line: string;
+  adatetime: TDateTime;
+  serPoint: TPointSeries;
+begin
+  for j := 2 to BIG_NUMBER do
+  begin
+    line := Piece(listofseries, '^' , j);
+    if length(line) < 1 then break;
+    linenum := strtointdef(line, -BIG_NUMBER);
+    if linenum = -BIG_NUMBER then break;
+    serPoint := TPointSeries.Create(aChart);
+    MakeSeriesPoint(aChart, serPoint);
+    with serPoint do
+    begin
+      serPoint.Title := '(non-numeric)';
+      serPoint.Identifier := (aChart.Series[linenum] as TCustomSeries).Title;
+      serPoint.Pointer.Style := (aChart.Series[linenum] as TCustomSeries).Pointer.Style;
+      serPoint.SeriesColor := (aChart.Series[linenum] as TCustomSeries).SeriesColor;
+      serPoint.Tag := BIG_NUMBER + linenum;
+    end;
+    for i := 0 to GtslNonNum.Count - 1 do
+    begin
+      avalue := GtslNonNum[i];
+      if Piece(avalue, '^', 7) = section then
+      begin
+        originalindex := strtointdef(Piece(avalue, '^', 3), 0);
+        if originalindex = linenum then
+        begin
+          adatetime := strtofloatdef(Piece(avalue, '^', 1), -BIG_NUMBER);
+          asernum := aChart.Tag;
+          if adatetime = -BIG_NUMBER then break;
+          if asernum = strtointdef(Piece(avalue, '^', 2), -BIG_NUMBER) then
+          begin
+            offset := strtointdef(Piece(avalue, '^', 5), 1);
+            graphvalue := padvalue * offset;
+            if copy(Piece(avalue, '^', 13), 0, 1) = '>' then
+              nonvalue := highestvalue
+            else
+              nonvalue := lowestvalue;
+            nonvalue := nonvalue + graphvalue;
+            with serPoint do
+            begin
+              Hint := Piece(avalue, '^', 9);
+              AddXY(adatetime, nonvalue, '', serPoint.SeriesColor);
+            end;
+          end;
+        end;
+      end;
+    end;
+  end;
+end;
+
+procedure TfrmGraphs.StackNonNum(astring: string; var offset, bmax, tmax: integer; var blabelon, tlabelon: boolean);
+var
+  inlist: boolean;
+  i, lastnum, plusminus: integer;
+  checktime, lasttime, avalue: string;
+begin
+  inlist := false;
+  offset := 0;
+  checktime := Piece(astring, '^', 1);
+  if length(checktime) < 4 then exit;
+  if copy(Piece(astring, '^', 13), 0, 1) = '>' then
+  begin
+    checktime := checktime + ';t';    // top values will stack downwards
+    plusminus := -1;
+    tlabelon := true;
+  end
+  else
+  begin
+    checktime := checktime + ';b';    // bottom values will stack upwards
+    plusminus := 1;
+    blabelon := true;
+  end;
+  for i := 0 to GtslNonNumDates.Count - 1 do
+  begin
+    avalue := GtslNonNumDates[i];
+    lasttime := Piece(avalue, '^' , 1);
+    if checktime = lasttime then
+    begin
+      lastnum := strtointdef(Piece(avalue, '^', 2), 0);
+      offset := lastnum + 1;
+      if offset > 0 then bmax := bmax + 1
+      else tmax := tmax + 1;
+      GtslNonNumDates[i] := checktime + '^' + inttostr(offset * plusminus);
+      inlist := true;
+      break;
+    end;
+  end;
+  if not inlist then
+    GtslNonNumDates.Add(checktime + '^' + inttostr(offset * plusminus));
+end;
+
+procedure TfrmGraphs.PadNonNum(aChart: TChart; aSection: string; var listofseries: string; var bmax, tmax: integer);
+var
+  blabelon, tlabelon: boolean;
+  i, offset: integer;
+  charttag, newtime, lasttime, astring, avalue, newseries: string;
+  serNonNumBottom, serNonNumTop: TPointSeries;
+begin
+  GtslNonNumDates.Clear;
+  listofseries := '^';
+  blabelon := false; tlabelon := false;
+  bmax := 0; tmax := 0;
+  lasttime := '';
+  for i := 0 to GtslNonNum.Count - 1 do
+  begin
+    astring   := GtslNonNum[i];
+    if Piece(astring, '^', 7) = aSection then
+    begin
+      charttag := Piece(astring, '^', 2);
+      if charttag = inttostr(aChart.Tag) then
+      begin
+        newtime   := Piece(astring, '^', 1);
+        avalue    := Piece(astring, '^', 13);
+        newseries := '^' + Piece(astring, '^', 3) + '^';
+        if Pos(newseries, listofseries) = 0 then
+          listofseries := listofseries + Piece(astring, '^', 3) + '^';
+        StackNonNum(astring, offset, bmax, tmax, blabelon, tlabelon);
+        SetPiece(astring, '^', 5, inttostr(offset));
+        GtslNonNum[i] := astring;
+      end;
+    end;
+  end;
+  if blabelon then
+  begin
+    serNonNumBottom := TPointSeries.Create(aChart);
+    MakeSeriesPoint(aChart, serNonNumBottom);
+    with serNonNumBottom do
+    begin
+      Identifier := 'serNonNumBottom';
+      Title := TXT_NONNUMERICS;
+      Marks.ArrowLength := -11;
+      Marks.Visible := true;
+    end;
+  end;
+  if tlabelon then
+  begin
+    serNonNumTop := TPointSeries.Create(aChart);
+    MakeSeriesPoint(aChart, serNonNumTop);
+    with serNonNumTop do
+    begin
+      Identifier := 'serNonNumTop';
+      Title := TXT_NONNUMERICS;
+      Marks.ArrowLength := -11;
+      Marks.Visible := true;
+    end;
+  end;
+end;
+
+function TfrmGraphs.PortionSize(lcnt, pcnt, gcnt, vcnt, bcnt: integer): double;
 var
   etotal, evalue, dvalue, value: double;
 begin
-  dvalue := (gcnt + vcnt + acnt);
+  dvalue := (gcnt + vcnt);
   evalue := (pcnt + bcnt) / 2;
   etotal := dvalue + evalue;
@@ -2108,5 +2748,5 @@
 
 procedure TfrmGraphs.MakeDateline(section, aTitle, aFileType: string; aChart: TChart; graphtype: integer;
-  var bcnt, pcnt, gcnt, vcnt, acnt: integer);
+  var bcnt, pcnt, gcnt, vcnt: integer);
 begin
   aChart.LeftAxis.Automatic := true;
@@ -2117,10 +2757,5 @@
     3:  MakeVisitGanttSeries(aChart, aTitle, aFileType, vcnt);
     4:  MakePointSeries(aChart, aTitle, aFileType, pcnt);
-    5:  MakeArrowSeries(aChart, aTitle, aFileType, acnt);
-    6:  MakeGanttSeries(aChart, aTitle, aFileType, gcnt);
-    7:  MakeAGanttSeries(aChart, aTitle, aFileType, gcnt);
-    8:  MakeManyGanttSeries(aChart, aTitle, aFileType, gcnt);
-    9:  MakeWeightedArrowSeries(aChart, aTitle, aFileType, acnt);
-   10:  MakeWeightedGanttSeries(aChart, aTitle, aFileType, gcnt);
+    8:  MakeGanttSeries(aChart, aTitle, aFileType, gcnt);
   end;
 end;
@@ -2158,23 +2793,4 @@
       aChart.LeftAxis.Title.Caption := 'StdDev';
   end;
-end;
-
-function TfrmGraphs.Vfactor(aTitle: string): double;  // returns first numbers in string
-var
-  firstnum: boolean;
-  i: integer;
-  vfactor: string;
-begin
-  vfactor := '';
-  firstnum := false;
-  for i := 0 to length(aTitle) - 1 do
-    if IsDelimiter('1234567890.', aTitle, i) then
-    begin
-      vfactor := vfactor + aTitle[i];
-      firstnum := true;
-    end
-    else
-      if firstnum = true then break;
-  Result := strtofloatdef(vfactor, 1);
 end;
 
@@ -2210,12 +2826,12 @@
 var
   tempcheck: boolean;
-  bottomview, i, j, topview: integer;
-  typeitem: string;
+  bottomview, topview: integer;
   aGraphItem: TGraphItem;
+  aListItem: TListItem;
 begin
   FFirstClick := true;
   if (lvwItemsTop.SelCount = 0) and (lvwItemsBottom.SelCount = 0) then exit;
-  topview := cboViewsTop.ItemIndex;
-  bottomview := cboViewsBottom.ItemIndex;
+  topview := lstViewsTop.ItemIndex;
+  bottomview := lstViewsBottom.ItemIndex;
   HideGraphs(true);
   with chkDualViews do
@@ -2229,28 +2845,75 @@
   chkItemsBottom.Checked := tempcheck;
   pnlBottom.Height := pnlMain.Height - pnlBottom.Height;
-  lstScratchSwap.Items.Clear;
+  GtslScratchSwap.Clear;
   if topview < 1 then
-    with lvwItemsTop do
-    for i := 0 to Items.Count - 1 do
-      if Items[i].Selected then
-      begin
-        aGraphItem := TGraphItem(Items.Item[i].SubItems.Objects[3]);
-        lstScratchSwap.Items.Add(aGraphItem.Values);
-      end;
+  begin
+    aListItem := lvwItemsTop.Selected;
+    while aListItem <> nil do
+    begin
+      aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
+      GtslScratchSwap.Add(aGraphItem.Values);
+      aListItem := lvwItemsTop.GetNextItem(aListItem, sdAll, [isSelected]);
+    end;
+  end;
+  GraphSwap(bottomview, topview);
+  GtslScratchSwap.Clear;
+  HideGraphs(false);
+end;
+
+procedure TfrmGraphs.GraphSwap(bottomview, topview: integer);
+var
+  tempcheck: boolean;
+begin
+  FFirstClick := true;
+  if (lvwItemsTop.SelCount = 0) and (lvwItemsBottom.SelCount = 0) then exit;
+  topview := lstViewsTop.ItemIndex;
+  bottomview := lstViewsBottom.ItemIndex;
+  HideGraphs(true);
+  with chkDualViews do
+    if not Checked then
+    begin
+      Checked := true;
+      Click;
+    end;
+  tempcheck := chkItemsTop.Checked;
+  chkItemsTop.Checked := chkItemsBottom.Checked;
+  chkItemsBottom.Checked := tempcheck;
+  pnlBottom.Height := pnlMain.Height - pnlBottom.Height;
+  GtslScratchSwap.Clear;
+  GraphSwitch(bottomview, topview);
+  HideGraphs(false);
+end;
+
+procedure TfrmGraphs.GraphSwitch(bottomview, topview: integer);
+var
+  i, j: integer;
+  typeitem: string;
+  aGraphItem: TGraphItem;
+  aListItem: TListItem;
+begin
+  GtslScratchSwap.Clear;
+  if topview < 1 then
+  begin
+    aListItem := lvwItemsTop.Selected;
+    while aListItem <> nil do
+    begin
+      aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
+      GtslScratchSwap.Add(aGraphItem.Values);
+      aListItem := lvwItemsTop.GetNextItem(aListItem, sdAll, [isSelected]);
+    end;
+  end;
   if bottomview > 0 then
   begin
-    cboViewsTop.ItemIndex := bottomview;
-    cboViewsTopChange(self);
+    lstViewsTop.ItemIndex := bottomview;
+    lstViewsTopChange(self);
   end
   else
   begin
-    cboViewsTop.ItemIndex := -1;
-    cboViewsTop.Text := '';
+    lstViewsTop.ItemIndex := -1;
     lvwItemsTop.ClearSelection;
-    with lvwItemsBottom do
-    for i := 0 to Items.Count - 1 do
-    if Items[i].Selected then
-    begin
-      aGraphItem := TGraphItem(Items.Item[i].SubItems.Objects[3]);
+    aListItem := lvwItemsBottom.Selected;
+    while aListItem <> nil do
+    begin
+      aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
       typeitem := Pieces(aGraphItem.Values, '^', 1, 2);
       for j := 0 to lvwItemsTop.Items.Count - 1 do
@@ -2263,4 +2926,5 @@
         end;
       end;
+      aListItem := lvwItemsBottom.GetNextItem(aListItem, sdAll, [isSelected]);
     end;
     lvwItemsTopClick(self);
@@ -2268,18 +2932,16 @@
   if topview > 0 then
   begin
-    cboViewsBottom.ItemIndex := topview;
-    cboViewsBottomChange(self);
+    lstViewsBottom.ItemIndex := topview;
+    lstViewsBottomChange(self);
   end
   else
   begin
-    cboViewsBottom.ItemIndex := -1;
-    cboViewsBottom.Text := '';
+    lstViewsBottom.ItemIndex := -1;
     lvwItemsBottom.ClearSelection;
-    with lstScratchSwap do
-    for i := 0 to Items.Count - 1 do
+    for i := 0 to GtslScratchSwap.Count - 1 do
       for j := 0 to lvwItemsBottom.Items.Count - 1 do
       begin
         aGraphItem := TGraphItem(lvwItemsBottom.Items.Item[j].SubItems.Objects[3]);
-        if aGraphItem.Values = Items[i] then
+        if aGraphItem.Values = GtslScratchSwap[i] then
         begin
           lvwItemsBottom.Items[j].Selected := true;
@@ -2289,13 +2951,8 @@
     lvwItemsBottomClick(self);
   end;
-  lstScratchSwap.Items.Clear;
-  HideGraphs(false);
+  GtslScratchSwap.Clear;
 end;
 
 procedure TfrmGraphs.mnuPopGraphSplitClick(Sender: TObject);
-var
-  i: integer;
-  typeitem, typenum: string;
-  aGraphItem: TGraphItem;
 begin
   FFirstClick := true;
@@ -2308,51 +2965,59 @@
       Click;
     end;
-  with cboViewsTop do
+  with lstViewsTop do
     if ItemIndex > -1 then
     begin
       ItemIndex := -1;
-      Text := '';
-    end;
-  with cboViewsBottom do
+    end;
+  with lstViewsBottom do
     if ItemIndex > -1 then
     begin
       ItemIndex := -1;
-      Text := '';
-    end;
+    end;
+    SplitClick;
+end;
+
+procedure TfrmGraphs.SplitClick;
+
+  procedure SplitGraphs(aListView: TListView);
+  var
+    typeitem: string;
+    aGraphItem: TGraphItem;
+    aListItem: TListItem;
+  begin
+    aListItem := lvwItemsTop.Selected;
+    while aListItem <> nil do
+    begin
+      aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
+      typeitem := Pieces(aGraphItem.Values, '^', 1, 2);
+      GtslScratchSwap.Add(typeitem);
+      aListItem := lvwItemsTop.GetNextItem(aListItem, sdAll, [isSelected]);
+    end;
+  end;
+
+var
+  i: integer;
+  typeitem, typenum: string;
+begin
   chkItemsTop.Checked := true;
   chkItemsBottom.Checked := false;
   pnlBottom.Height := pnlMain.Height - pnlBottom.Height;
-  lstScratchSwap.Items.Clear;
-  with lvwItemsTop do
-    for i := 0 to Items.Count - 1 do
-    if Items[i].Selected then
-    begin
-      aGraphItem := TGraphItem(Items.Item[i].SubItems.Objects[3]);
-      typeitem := Pieces(aGraphItem.Values, '^', 1, 2);
-      lstScratchSwap.Items.Add(typeitem);
-    end;
-  with lvwItemsBottom do
-    for i := 0 to Items.Count - 1 do
-    if Items[i].Selected then
-    begin
-      aGraphItem := TGraphItem(Items.Item[i].SubItems.Objects[3]);
-      typeitem := Pieces(aGraphItem.Values, '^', 1, 2);
-      lstScratchSwap.Items.Add(typeitem);
-    end;
+  GtslScratchSwap.Clear;
+  SplitGraphs(lvwItemsTop);
+  SplitGraphs(lvwItemsBottom);
   lvwItemsTop.ClearSelection;
   lvwItemsBottom.ClearSelection;
-  with lstScratchSwap do
-    for i := 0 to Items.Count - 1 do
-    begin
-      typeitem := Items[i];
-      typenum := Piece(typeitem, '^', 1);
-      if (typenum = '63') or (typenum = '120.5') then
-        SelectItem(lvwItemsTop, typeitem)
-      else
-        SelectItem(lvwItemsBottom, typeitem);
-    end;
+  for i := 0 to GtslScratchSwap.Count - 1 do
+  begin
+    typeitem := GtslScratchSwap[i];
+    typenum := Piece(typeitem, '^', 1);
+    if (typenum = '63') or (typenum = '120.5') then
+      SelectItem(lvwItemsTop, typeitem)
+    else
+      SelectItem(lvwItemsBottom, typeitem);
+  end;
   lvwItemsTopClick(self);
   lvwItemsBottomClick(self);
-  lstScratchSwap.Items.Clear;
+  GtslScratchSwap.Clear;
   HideGraphs(false);
 end;
@@ -2382,4 +3047,39 @@
   with FGraphSetting do View3D := not View3D;
   ChangeStyle;
+end;
+
+procedure TfrmGraphs.mnuPopGraphValueMarksClick(Sender: TObject);
+var
+  i: integer;
+begin
+  if (FGraphSeries is TPointSeries) and not (FGraphSeries is TGanttSeries) then
+  begin
+    if (FGraphSeries as TPointSeries).Pointer.Style = psSmallDot then exit;    // keep non-numeric label unchanged
+    if Piece(FGraphSeries.Title, '^', 1) = '(non-numeric)' then
+    begin
+      FGraphSeries.Marks.Visible := not FGraphSeries.Marks.Visible;
+      for i := 0 to FGraphClick.SeriesCount - 1 do
+      begin
+        if FGraphClick.Series[i].Title = FGraphSeries.Identifier then
+        begin
+          FGraphClick.Series[i].Marks.Visible := FGraphSeries.Marks.Visible;
+          if FGraphSeries.Title <> 'Blood Pressure' then break;
+        end;
+      end;
+    end;
+  end
+  else if chartDatelineTop.Tag = 1 then               // series
+  begin
+    FGraphSeries.Marks.Visible := not FGraphSeries.Marks.Visible;
+    for i := 0 to FGraphClick.SeriesCount - 1 do
+    begin
+      if (FGraphClick.Series[i].Identifier = FGraphSeries.Title)
+      or (FGraphClick.Series[i].Title = FGraphSeries.Title) then
+      begin
+        FGraphClick.Series[i].Marks.Visible := FGraphSeries.Marks.Visible;
+        if FGraphSeries.Title <> 'Blood Pressure' then break;
+      end;
+    end;
+  end;
 end;
 
@@ -2425,5 +3125,5 @@
   end;
   ChangeStyle;
-  // redisplay if nonnumericonly graph exists
+  // ???redisplay if nonnumericonly graph exists
   if pnlItemsTop.Tag = 1 then lvwItemsTopClick(self);
   if pnlItemsBottom.Tag = 1 then lvwItemsBottomClick(self);
@@ -2450,4 +3150,19 @@
 end;
 
+procedure TfrmGraphs.mnuPopGraphViewDefinitionClick(Sender: TObject);
+begin
+  mnuPopGraphViewDefinition.Checked := not mnuPopGraphViewDefinition.Checked;
+  if mnuPopGraphViewDefinition.Checked  then
+  begin
+    memViewsTop.Height := (tsTopViews.Height div 3) + 1;
+    memViewsBottom.Height := (tsBottomViews.Height div 3) + 1;
+  end
+  else
+  begin
+    memViewsTop.Height := 1;
+    memViewsBottom.Height := 1;
+  end;
+end;
+
 procedure TfrmGraphs.mnuPopGraphDatesClick(Sender: TObject);
 begin
